﻿using System;
using System.Collections.Specialized;

namespace RinGOch
{
	public class HttpException : Exception
	{
		public int ErrorNumber;
		public string ErrorMessage;
		public StringDictionary ResponseFields;

		public HttpException(int error,string msg)
		{
			ErrorNumber = error;
			ErrorMessage = msg;
			ResponseFields = new StringDictionary();
		}

		public HttpException(int error,string msg,params string[] resFields)
		{
			ErrorNumber = error;
			ErrorMessage = msg;
			ResponseFields = new StringDictionary();

			for(int i=0;i<resFields.Length;i+=2)
			{
				ResponseFields.Add(resFields[i],resFields[i+1]);
			}
		}

		public HttpException(int error,string msg,StringDictionary res)
		{
			ErrorNumber = error;
			ErrorMessage = msg;
			ResponseFields = res;
		}

		public static HttpException UnauthorizedException
		{
			get
			{
				return new HttpException(401,"Unauthorized","WWW-Authenticate","Basic realm=\"RinGOchArea\"");
			}
		}
	}
}
