﻿using System;
using System.Runtime.InteropServices;
using System.Text;

namespace RinGOch
{
	public class IniMgr
	{
		[DllImport("kernel32")]
		private static extern long WritePrivateProfileString(string section,string key,string val,string filePath);
		[DllImport("kernel32")]
		private static extern int GetPrivateProfileString(string section,string key,string def,StringBuilder retVal,int size,string filePath);

		public static string path;
		protected const int bufferSize = 512;
		public static string read(string key)
		{
			return read(key,"");
		}
		public static string read(string key,string def)
		{
			return read("DATA",key,def);
		}
		public static int read(string key,int def)
		{
			return int.Parse(read("DATA",key,def.ToString()));
		}
		public static int read(string section,string key,int def)
		{
			return int.Parse(read(section,key,def.ToString()));
		}
		public static string read(string section,string key,string defVal)
		{
			try
			{
				StringBuilder temp = new StringBuilder(bufferSize);
				int ret = GetPrivateProfileString(section,key,defVal,temp,bufferSize,path);
				return temp.ToString();
			}
			catch
			{
				return defVal;
			}
		}
		public static void write(string key,int Value)
		{
			write(key,Value.ToString());
		}
		public static void write(string section,string key,int Value)
		{
			write(section,key,Value.ToString());
		}
		public static void write(string key,string Value)
		{
			WritePrivateProfileString("DATA",key,Value,path);
		}
		public static void write(string section,string key,string Value)
		{
			WritePrivateProfileString(section,key,Value,path);
		}
	}
}
