﻿using System;
using System.Collections;
using System.Collections.Specialized;

namespace RinGOch.PostProcessors
{
	public class ManagementProcessor
	{
		public static byte[] Process(StringDictionary param)
		{
			if(HttpServer.HasAuthority(param))
			{
				ArrayList deletePosts = new ArrayList();
				Guid id;
				string title,cate;

				// ページGUIDを取得。
				try
				{
					id = new Guid(param["id"]);
					WebHeaderInfo info = WebCacheReader.ReadHeader(id);
					if(info == null)throw new Exception();
					title = param["title"];
					cate = param["category"];
				}
				catch
				{
					return HttpServerSetting.HtmlEncoding.GetBytes("Not Found PageGuid");
				}

				// 削除する記事のGUIDを取得
				foreach(DictionaryEntry entry in param)
				{
					if(entry.Key.ToString().StartsWith("-") && entry.Value.ToString().Equals("delete"))
					{
						try
						{
							deletePosts.Add(new Guid(entry.Key.ToString().Substring(1)));
						}
						catch{}
					}
				}

				// 管理更新
				string ret = Interface.ManagePage(id,title,cate,(Guid[])deletePosts.ToArray(typeof(Guid)));

				string temp = HttpHtmlGenerator.ReadTemplateFile("template\\manage\\manage_result.html");
				if(ret == "")
				{
					// 空文字を返したときは管理更新成功
					return HttpServerSetting.HtmlEncoding.GetBytes(temp.Replace(TextUtility.GetMiddleRangeString(temp,"<!--BEGIN FAILURE-->","<!--END FAILURE-->"),""));
				}
				else
					return HttpServerSetting.HtmlEncoding.GetBytes(temp.Replace(TextUtility.GetMiddleRangeString(temp,"<!--BEGIN SUCCESS-->","<!--END SUCCESS-->"),"").Replace("%RESULT%",ret));
			}
			else
			{
				throw HttpException.UnauthorizedException;
			}
		}
		public static byte[] ProcessDelete(StringDictionary param)
		{
			try
			{
				if(HttpServer.HasAuthority(param))
				{			
					Guid id = new Guid(param["guid"]);
					Interface.IgnorePage(id,2);

					string temp = HttpHtmlGenerator.ReadTemplateFile("template\\gateway\\basic.html");
					temp = HtmlGenerators.TemplateFieldReplacer.ReplaceField(temp,"%TITLE%","管理マネージャ");
					temp = HtmlGenerators.TemplateFieldReplacer.ReplaceField(temp,"%BODY%",
						"タイトル：" + param["title"] + "<br>" +
						"GUID：" + id.ToString() + "<br>" + 
						"のキャッシュを削除しました。");

					return HttpServerSetting.HtmlEncoding.GetBytes(temp);
				}
				else
				{
					throw HttpException.UnauthorizedException;
				}
			}
			catch(HttpException)
			{
				throw;
			}
			catch(Exception ex)
			{
				return HtmlGenerators.ErrorHtml.Generate("スレを無視リストに追加しようとしたところ例外が発生しました",ex);
			}
		}
		public static byte[] ProcessIgnore(StringDictionary param)
		{
			try
			{
				if(HttpServer.HasAuthority(param))
				{
					string body = "";
					if (param.ContainsKey("action") && (param["action"] == "reload"))
					{
						Interface.IgnorePage(Guid.Empty, 3);
						WebPageManager.ApplyIgnore();
						body = "無視リストを再読み込みしました";
					}
					else if (param.ContainsKey("guids") && param.ContainsKey("titles"))
					{
						string[] guids = param["guids"].Split(',');
						string[] titles = param["titles"].Replace("<>","\0").Split('\0');
						string text = "";
						if(guids.Length == titles.Length)
						{
							for(int i=0;i<guids.Length;i++)
							{
								Guid id = new Guid(guids[i]);
								WebPageManager.AppendIgnore(id,titles[i]);
								Interface.IgnorePage(id,0);
								text += HttpUtility.HtmlEncode(titles[i] + " [" + guids[i] + "]") + "<br>";
							}
							body = text + "<br>" + "を無視リストに追加しました。";
						}
						else
							throw new Exception("タイトルとGUIDの数が合いません");
					}
					else if(param.ContainsKey("guid"))
					{
						Guid id = new Guid(param["guid"]);
						WebPageManager.AppendIgnore(id,param["title"]);
						Interface.IgnorePage(id,0);
						body = HttpUtility.HtmlEncode(param["title"] + " [" + id.ToString() + "]") + "<br>" + "を無視リストに追加しました。";
					}
					else
						throw new Exception("対応していないパラメータです");

					string temp = HttpHtmlGenerator.ReadTemplateFile("template\\gateway\\basic.html");
					temp = HtmlGenerators.TemplateFieldReplacer.ReplaceField(temp,"%TITLE%","管理マネージャ");
					temp = HtmlGenerators.TemplateFieldReplacer.ReplaceField(temp,"%BODY%",body);

					return HttpServerSetting.HtmlEncoding.GetBytes(temp);
				}
				else
				{
					throw HttpException.UnauthorizedException;
				}
			}
			catch(HttpException)
			{
				throw;
			}
			catch(Exception ex)
			{
				return HtmlGenerators.ErrorHtml.Generate("スレを無視リストに追加しようとしたところ例外が発生しました",ex);
			}
		}
	}
}
