﻿using System;
using System.Collections;
using System.Runtime.InteropServices;
using System.Text.RegularExpressions;
using System.Text;

namespace RinGOch
{
	public class TxtEnc: IDisposable
	{
	
		protected const int CD_JPN_ISO2022 = 0;
		protected const int CD_JPN_SJIS = 1;
		protected const int CD_JPN_EUC = 2;
		protected const int CD_UTF_8 = 3;
	

		protected string srcCodec;
		protected int srcCodecIndex;
		protected string srcText;
		protected byte[] srcByte;
		protected int[] srcCountCodec;
		protected int[] srcExCodec;
		protected int srcMaxRead;
		protected bool srcCodeBreak;

		public static string AutoConvert(byte[] data)
		{
			TxtEnc te = new TxtEnc();
			te.MaxRead = 0;te.CodeBreak=false;
			te.SetByteArray(ref data);
			try
			{
				if(te.Codec == null || te.Codec == "")
					return Encoding.UTF8.GetString(data);
				else
					return Encoding.GetEncoding(te.Codec).GetString(data);
			}
			catch
			{
				return Encoding.UTF8.GetString(data);
			}
		}

		public TxtEnc()
		{//コンストラクタ
			srcMaxRead=2048;
			srcCodeBreak=true;
		}

		public void Dispose()
		{
			// デストラクタみたいなもの
		
			GC.SuppressFinalize(this);
		}

		public string Text
		{
			get 
			{//何かしらの操作をしないと戻らない
				return srcText; 
			}
			set 
			{//Unicodeで突入
				//srcText=value;
				srcByte=Encoding.Unicode.GetBytes(value);
				srcCodec="utf-16";
			}
		}
		public int[] CountCodec
		{
			get
			{
				return srcCountCodec;
			}
		}
		public int[] CountExCodec
		{
			get
			{
				return srcExCodec;
			}
		}
		public int MaxRead
		{
			get 
			{
				return srcMaxRead; 
			}
			set 
			{
				srcMaxRead=value;
			}		
		}
		public int ExCodec
		{
			get 
			{
				return srcExCodec[srcCodecIndex]; 
			}
		}
		public bool CodeBreak
		{
			get 
			{
				return srcCodeBreak; 
			}
			set 
			{
				srcCodeBreak=value;
			}		
		}

		public string Codec
		{
			get 
			{
				return srcCodec; 
			}
			set 
			{//変換
				if(srcCodec!="")
				{
				
					srcByte=Encoding.Convert(Encoding.GetEncoding(srcCodec),Encoding.GetEncoding(value),srcByte);
					//dbg用
					//srcText= srcCodec +"━━━(ﾟ∀ﾟ)━( ﾟ∀)━━(∀ﾟ )━(ﾟ∀ﾟ)━━━!!\nExCodec="+srcExCodec[srcCodecIndex]+"\n";
					//srcCodec=value;
					//srcText+= Encoding.GetEncoding(srcCodec).GetString(srcByte);
										
					//release用
					srcCodec=value;
					srcText=Encoding.GetEncoding(srcCodec).GetString(srcByte);
				}
			}
		}



	
		public void SetByteArray(ref byte[]txt)
		{//判別
			int AS=txt.Length-1,//最大サイズ
				RP=0,			//リードポインタ
				RS=srcMaxRead;	//最大読み込みサイズ
			int i;
			int[] code = new int[4];		//Code
			int[] excode = new int[4];		//Excode
			int code2=-1;					//確定コードindex
			int code3=-1;					//code state -2=確定もしくは可能性 -1=疑惑なし 0～=疑惑index
			srcByte=txt;

			//ReadSize調整
			if(AS==0){return;}
			else if(RS==0){RS=AS;}
			else if(RS>AS){RS=AS;}
		
			while(RP<RS)
			{//判定メインループ

				if(txt[RP]==0x1B)
				{//JIS
					code[CD_UTF_8]=-1;
					if(Chk_JPN_ISO2022(ref txt,ref RP,RS,AS,ref code,ref excode,ref code2,ref code3)==false){RP++;}
					else if(srcCodeBreak==true && code2!=-1){break;}
				}
				else if(txt[RP]>0x7F)
				{
					if(txt[RP]>0xBF && txt[RP]<0xFE)
					{//UTF
						if(Chk_Unicode(ref txt,ref RP,RS,AS,ref code,ref excode,ref code2,ref code3)==false)
						{
							code[CD_UTF_8]=-1;
							if(Chk_JPN_SJIS_EUC(ref txt,ref RP,RS,AS,ref code,ref excode,ref code2,ref code3)==false){RP++;}
							else if(srcCodeBreak==true && code2!=-1){break;}
						}
						else if(srcCodeBreak==true && code2!=-1){break;}
					}
					else
					{//SJIS EUC
						code[CD_UTF_8]=-1;
						if(Chk_JPN_SJIS_EUC(ref txt,ref RP,RS,AS,ref code,ref excode,ref code2,ref code3)==false){RP++;}
						else if(srcCodeBreak==true && code2!=-1){break;}
					}

				}
				else
				{
					//ASCIIとかJISとか
					RP++;
				}
			}
			if(code2==-1)
			{//確定でない
				if(code3>-1)
				{//疑惑確定
					code2=code3;
				}
				code2=0;
				for(i=1;i<4;i++)
				{
					if(code[i] > code[code2]){code2=i;}
				}
			}
			srcExCodec=excode;
			srcCountCodec=code;
			srcCodecIndex=code2;
			switch(code2)
			{
				case CD_JPN_ISO2022:
					srcCodec="iso-2022-jp";
					break;
				case CD_JPN_SJIS:
					srcCodec="shift_jis";
					break;
				case CD_JPN_EUC:
					srcCodec="euc-jp";
					break;
				case CD_UTF_8:
					srcCodec="utf-8";
					break;
				default:
					srcCodec="iso-2022-jp";
					break;
			}

		}



		public void SetByteArray(ref byte[]txt,string sCodec)
		{//判別済み
			srcCodec=sCodec;
			srcByte=txt;
		}

		protected bool Chk_Unicode(ref byte[]txt,ref int RP,int RS,int AS,ref int[] code,ref int[] excode,ref int code2,ref int code3)
		{//Unicode系判別
			/*
			UTF-8
			Index		CD_UTF_8	(3)

			Excodec		1=ERROR		(Break UTF-8 double first byte)
						2=Include	(Byte Order Mark)
						4=Include	(0xC0 0xC1)
						8=UCS-4		(RFC2279)
			*/
			if(!(code2==-1 || code2==CD_UTF_8)
				|| code[CD_UTF_8]==-1){return false;}//確定コード回避
			int size=0,
				i;
			bool brcode=false;
			if(txt[RP]>0xBF && txt[RP]<0xFE)
			{//UTF-8
			
				//可変長サイズ決定
				if((txt[RP] & 0xFC) == 0xFC)
				{
					size=5;
					excode[CD_UTF_8]|=8;//UCS-4
				}
				else if((txt[RP] & 0xF8) == 0xF8)
				{
					size=4;
					excode[CD_UTF_8]|=8;//UCS-4
				}
				else if((txt[RP] & 0xF0) == 0xF0){size=3;}
				else if((txt[RP] & 0xE0) == 0xE0)
				{
					size=2;
					if(txt[RP]==0xEF && txt[RP+1]==0xBB && txt[RP+2]==0xBF)
					{//BOM
						excode[CD_UTF_8]|=2;
						code[CD_UTF_8]+=3;//BOM CNT
						RP+=3;
						return true;
					}
				}
				else if(txt[RP] == 0xC0 || txt[RP] == 0xC1)
				{
					//0xC0 0xC1 Security
					excode[CD_UTF_8]|=4;
					size=1;
				}
				else if((txt[RP] & 0xC0) == 0xC0){size=1;}
			
				if(RP+size>AS)
				{//UTFで指定されてるサイズがオーバーしてる
					return false;
				}
				for(i=RP+1;i<=RP+size;i++)
				{
					if(!(txt[i] >0x7F && txt[i] <0xC0))
					{
						if(txt[i] >0xBF && txt[i] <0xFE && i==RP+1 && code3!=-2)
						{//ダブりバグ？(連続する事がある
							//size++;
							brcode=true;
						}
						else{return false;}
					}
				}
				if(brcode==true)
				{//壊れてるUTFの可能性ｱﾘ
					excode[CD_UTF_8]|=1;
					code3=CD_UTF_8;
				}
				else
				{
					code[CD_UTF_8]++;//UTF-8判定
					code3=-2;
				}
				RP+=size+1;
				return true;
			}
			return false;
		}
		protected bool Chk_JPN_ISO2022(ref byte[]txt,ref int RP,int RS,int AS,ref int[] code,ref int[] excode,ref int code2,ref int code3)
		{
			/*
			ISO-2022-JP
			Index		CD_JPN_ISO2022
			Excode		1		=SI/SO
						2		=JIS X 0208-1978
						4		=JIS X 0208-1983
						8		=JIS X 0208-1990
						16		=JIS X 0213:2000 1面
						32		=JIS X 0213:2000 2面
						64		=JIS X 0201-1976 片仮名
						128		=ASCII
						256		=JIS X 0201-1976 Roman Set(0x1B 0x28 0x4A)
						512		=JIS X 0201-1976 Roman Set(0x1B 0x28 0x48)
						1024	=JIS X 0208-1990
			*/ 
			if(!(code2==-1 || code2==CD_JPN_ISO2022)
				|| code[CD_JPN_ISO2022]==-1){return false;}//確定コード回避
			if(txt[RP]==0x0E ||txt[RP]==0x0F)
			{//SI SO判定
				excode[CD_JPN_ISO2022]|=1;
			}
			else if(txt[RP]==0x1B)
			{//JIS ESC
				if(AS >=RP+2)
				{
					if (txt[RP+1]==0x24)
					{
						if(txt[RP+2]==0x40)
						{//0x1B 0x24 0x40 JIS X 0208-1978
							code[CD_JPN_ISO2022]+=1;
							excode[CD_JPN_ISO2022]|=2;
							code2=CD_JPN_ISO2022;
							code3=-2;
							RP+=3;
							return true;
						}
						else if(txt[RP+2]==0x42)
						{//0x1B 0x24 0x42 JIS X 0208-1983
							code[CD_JPN_ISO2022]+=1;
							excode[CD_JPN_ISO2022]|=4;
							code2=CD_JPN_ISO2022;
							code3=-2;
							RP+=3;
							return true;
						}
						else if(AS >=RP+3)
						{
							if(txt[RP+2]==0x28)
							{
								if(txt[RP+3]==0x44)
								{//0x1B 0x24 0x28 0x44 JIS X 0208-1990
									code[CD_JPN_ISO2022]+=1;
									excode[CD_JPN_ISO2022]|=8;
									code2=CD_JPN_ISO2022;
									code3=-2;
									RP+=4;
									return true;
								}
								else if(txt[RP+3]==0x4F)
								{//0x1B 0x24 0x28 0x4F JIS X 0213:2000 1面
									code[CD_JPN_ISO2022]+=1;
									excode[CD_JPN_ISO2022]|=16;
									code2=CD_JPN_ISO2022;
									code3=-2;
									RP+=4;
									return true;
								}
								else if(txt[RP+3]==0x50)
								{//0x1B 0x24 0x28 0x50 JIS X 0213:2000 2面
									code[CD_JPN_ISO2022]+=1;
									excode[CD_JPN_ISO2022]|=32;
									code2=CD_JPN_ISO2022;
									code3=-2;
									RP+=4;
									return true;
								}
							}
						}
					}
					else if (txt[RP+1]==0x28)
					{
						if(txt[RP+2]==0x49)
						{//1B 28 49 JIS X 0201-1976 片仮名
							code[CD_JPN_ISO2022]+=1;
							excode[CD_JPN_ISO2022]|=64;
							code2=CD_JPN_ISO2022;
							code3=-2;
							RP+=3;
							return true;
						}
						else if(txt[RP+2]==0x42)
						{//1B 28 42 ASCII
							code[CD_JPN_ISO2022]+=1;
							excode[CD_JPN_ISO2022]|=128;
							code2=CD_JPN_ISO2022;
							code3=-2;
							RP+=3;
							return true;
						}
						else if(txt[RP+2]==0x4A)
						{//1B 28 4A JIS X 0201-1976 Roman Set
							code[CD_JPN_ISO2022]+=1;
							excode[CD_JPN_ISO2022]|=256;
							code2=CD_JPN_ISO2022;
							code3=-2;
							RP+=3;
							return true;
						}
						else if(txt[RP+2]==0x48)
						{//1B 28 48 JIS X 0201-1976 Roman Set
							code[CD_JPN_ISO2022]+=1;
							excode[CD_JPN_ISO2022]|=512;
							code2=CD_JPN_ISO2022;
							code3=-2;
							RP+=3;
							return true;
						}
					}
					else if(AS >=RP+5)
					{
						if(txt[RP+1]==0x26 &&
							txt[RP+2]==0x40 &&
							txt[RP+3]==0x1B &&
							txt[RP+4]==0x24 &&
							txt[RP+5]==0x42)
						{//0x1B 0x26 0x40 0x1B 0x24 0x42 JIS X 0208-1990
							code[CD_JPN_ISO2022]+=1;
							excode[CD_JPN_ISO2022]|=1024;
							code2=CD_JPN_ISO2022;
							code3=-2;
							RP+=6;
							return true;
						}
					}
				}
			}
			return false;
		}
		protected bool Chk_JPN_SJIS_EUC(ref byte[]txt,ref int RP,int RS,int AS,ref int[] code,ref int[] excode,ref int code2,ref int code3)
		{
			/*
			SJIS
			Index		CD_JPN_SJIS
			*/ 
			/*
			EUC
			Index		CD_JPN_EUC
			*/ 
			if(!(code2==-1 || code2==CD_JPN_SJIS || code2==CD_JPN_EUC)
				|| (code[CD_JPN_SJIS]==-1 && code[CD_JPN_EUC]==-1)){return false;}//確定コード回避

			if(txt[RP]==0x8E && RP+1<=AS && (code2==CD_JPN_EUC || code2==-1) && code[CD_JPN_EUC]!=-1)
			{//8EはEUCにおける半角のエスケープシークエンス
				if(txt[RP+1]>0xA0 && txt[RP+1]<0xE0 && 
					(code3!=-2 || code3==CD_JPN_EUC))
				{//a1->df範囲はsjisとの衝突
					code[CD_JPN_EUC]++;
					code3=-2;
					RP++;//とりあえずEUC判定して次へスルー(使われる範囲のSJISにおける漢字が単独ではあまり使われない)
					return true;

				}
				else if(txt[RP+1]>0x7F && txt[RP+1]<0xA1 && code[CD_JPN_SJIS]!=-1)
				{//SJIS確定
					code[CD_JPN_SJIS]++;
					code2=CD_JPN_SJIS;
					code3=-2;
					RP+=2;
					return true;
				}
				else
				{//不明コード
					return false;
				}
			}
			//補助漢字が入らない場合はここからコメントアウト
			if(txt[RP]==0x8F && RP+2<=AS && (code2==CD_JPN_EUC || code2==-1)&& code[CD_JPN_EUC]!=-1)
			{//8EはEUCにおける補助漢字のエスケープシークエンス
				if(txt[RP+1]>0xA0 && txt[RP+1]<0xFF && 
					txt[RP+2]>0xA0 && txt[RP+2]<0xFF)
				{

					code[CD_JPN_EUC]++;
					code3=-2;
					if((txt[RP+1]==0xFD || txt[RP+1]==0xFE)||
						(txt[RP+2]==0xFD || txt[RP+2]==0xFE))
					{//0xFD 0xFE EUC美乳
						RP+=2;
						code2=CD_JPN_EUC;
						return true;//breakと同意
					}

					RP++;//とりあえずEUC判定して次へスルー(とりあえず他の可能性もあるので+1)
					return true;
						
				}
				else if(txt[RP+1]>0x7F && txt[RP+1]<0xA1 && code[CD_JPN_SJIS]!=-1)
				{//SJIS確定
					code[CD_JPN_SJIS]++;
					code2=CD_JPN_SJIS;
					code3=-2;
					RP+=2;
					return true;
				}
				else
				{//不明コード
					return false;
				}
			}
				//補助漢字が入らない場合はここまでコメントアウト
			else
			{
				if(txt[RP]>0x7F && txt[RP]<0xA1 && (code2==CD_JPN_SJIS || code2==-1) && code[CD_JPN_SJIS]!=-1)
				{//SJIS確定
					code[CD_JPN_SJIS]++;
					code2=CD_JPN_SJIS;
					code3=-2;
					RP++;
					return true;
				}

				else if(txt[RP]>0xA0 && txt[RP]<0xE0 && 
					(code2==-1 || code2==CD_JPN_SJIS) && 
					(code3!=-2 || code3==CD_JPN_SJIS) &&
					code[CD_JPN_SJIS]!=-1)
				{//SJIS半角
					if(RP+1<=AS)
					{
						if((txt[RP]==0xA4 && (txt[RP+1]>0xA0 && txt[RP+1]<0xF4))
							||(txt[RP]==0xA5 && (txt[RP+1]>0xA0 && txt[RP+1]<0xF7))&& code[CD_JPN_EUC]!=-1)
						{
							//EUCの場合はA4+?でかな A5+?でカナになる SJIS半角カナ条件にはいる
							//この条件のみSJIS半角から除外する
							//EUC全角カナ？
							code[CD_JPN_EUC]++;
							code3=CD_JPN_EUC;
							RP+=2;
							return true;

						}
						else if(txt[RP+1]>0xDF && txt[RP+1]<0xFF && code[CD_JPN_EUC]!=-1)
						{//SJIS半角カナ以外でのEUC範囲がでたためEUC
							code[CD_JPN_EUC]++;
							code3=-2;
							if((txt[RP+1]==0xFD || txt[RP+1]==0xFE)||
								(txt[RP+2]==0xFD || txt[RP+2]==0xFE))
							{//0xFD 0xFE EUC美乳
								RP+=2;
								code2=CD_JPN_EUC;
								return true;//breakと同意
							}

							RP++;//とりあえずEUC判定して次へスルー(とりあえず他の可能性もあるので+1)
							return true;
						}
						else
						{//EUC外
							//SJIS半角の可能性
							code[CD_JPN_SJIS]++;
							code3=-2;
							RP++;
							return true;
						}
					}
					else
					{
						//SJISの可能性
						code[CD_JPN_SJIS]++;
						code3=-2;
						RP++;
						return true;
					}
				}
				else if(txt[RP]>0xA0 && txt[RP]<0xFF
					&& (code2==CD_JPN_EUC || code2==-1)
					&& code[CD_JPN_EUC]!=-1)
				{//EUC
					code[CD_JPN_EUC]++;
					code3=-2;
					RP++;
					if(txt[RP]==0xFD || txt[RP]==0xFE)
					{//0xFD 0xFE EUC
						code2=CD_JPN_EUC;
					}
					return true;
				}
				else
				{
					return false;
				}

			}						
			//			return false;
		}


	}
	
}