﻿using System;
using System.Collections;
using System.IO;

namespace RinGOch
{
	public class WebPageManager
	{
		#region 無視リスト
		public static string _ignorePath = Path.Combine(System.Environment.CurrentDirectory,"Settings\\IgnoreThread.dat");

		#region 追加
		public static void AppendIgnore(Guid id,string title)
		{
			TextUtility.AppendText(_ignorePath,id.ToString() + "\t" + title + "\r\n");
			WebPageUpdateFlag.RemovePage(id);
		}
		#endregion

		#region 削除
		public static void RemoveIgnore(Guid id)
		{
			string[] lines = TextUtility.ReadTextFile(_ignorePath,false);
			string sid = id.ToString();
			ArrayList list = new ArrayList(lines);
			foreach(string line in lines)
			{
				if(line.StartsWith(sid))
					list.RemoveAt(Array.IndexOf(lines,line));
			}

			string temp = string.Join("\r\n",(string[])list.ToArray(typeof(string)));
			temp = temp.TrimEnd('\r','\n') + "\r\n";
			TextUtility.WriteText(_ignorePath,temp);
		}
		#endregion

		#region すべて反映
		public static void ApplyIgnore()
		{
			string[] lines = TextUtility.ReadTextFile(_ignorePath,false);
			foreach(string line in lines)
			{
				string temp = line.Split('\t')[0];
				try
				{
					Interface.IgnorePage(new Guid(temp),0);
				}
				catch
				{
				}
			}
		}
		#endregion

		#endregion
	}
}
