using System;
using System.Collections;
using System.Text;
using System.Text.RegularExpressions;

namespace RinGOch.WikiEngine
{
	/// <summary>
	/// \[XR[hp̒Ft@CpāAtH[}bg܂
	/// </summary>
	public class CodeTagReplacer
	{
		const string TAG_CODE = "code";
		const string TAG_BEGIN = "&lt;";
		const string TAG_END = "&gt;";

		static string _color = "";
		static string _style = "";

		public static string Transform(string contents)
		{
			return Regex.Replace(contents,@"^&lt;code lang=&quot;(?<lang>[^&]+?)&quot;&gt;(?<source>(.|\s)+?)&lt;/code&gt;",new MatchEvaluator(CodeReplacer),RegexOptions.Multiline);
			//return Regex.Replace(contents,@"&lt;code lang=&quot;(?<lang>[^&]+?)&quot;>(?<source>.+?)&lt;/code>",new MatchEvaluator(CodeReplacer),RegexOptions.Singleline);
			//return Regex.Replace(contents,@"<code lang=&quot;(?<lang>[^&]+?)&quot;>(?<source>.+?)</code>",new MatchEvaluator(CodeReplacer),RegexOptions.Singleline);
		}

		public static string CodeReplacer(Match match)
		{
			string code = HttpUtility.HtmlEncode(HttpUtility.HtmlDecode(match.Groups["source"].Value));
			string lang = match.Groups["lang"].Value;

			string langFile = HttpHtmlGenerator.ReadTemplateFile("template\\code\\" + lang);
			string[] lines = langFile.Split('\n');
			string pattern = "";
			string colorType = "";

			string[] wc = new string[3];
			string[] ws = new string[3];
			string[] lc = new string[3];
			string[] ls = new string[3];
			string[] sc = new string[3];
			string[] ss = new string[3];

			bool flag = false;
			foreach(string line in lines)
			{
				if(line.ToLower().StartsWith("[setting"))
					flag = true;
				else if(flag && line.StartsWith("["))
					flag = false;

				if(flag)
				{
					if(line.ToLower().StartsWith("wordcolors="))
						wc = line.Substring(line.IndexOf("=")+1).Split(',');
					if(line.ToLower().StartsWith("wordstyles="))
						ws = line.Substring(line.IndexOf("=")+1).Split(',');
					if(line.ToLower().StartsWith("linecolors="))
						lc = line.Substring(line.IndexOf("=")+1).Split(',');
					if(line.ToLower().StartsWith("linestyles="))
						ls = line.Substring(line.IndexOf("=")+1).Split(',');
					if(line.ToLower().StartsWith("spancolors="))
						sc = line.Substring(line.IndexOf("=")+1).Split(',');
					if(line.ToLower().StartsWith("spanstyles="))
						ss = line.Substring(line.IndexOf("=")+1).Split(',');
				}
			}

			foreach(string line in lines)
			{
				if(line.StartsWith("["))
				{
					if(pattern != "")
					{
						int index = int.Parse(colorType.Substring(colorType.IndexOf("]")-1,1)) - 1;
						string[] c = new string[3];
						string[] s = new string[3];
						if(colorType.ToLower().StartsWith("[word"))
						{
							c = wc;s = ws;
						}
						else if(colorType.ToLower().StartsWith("[line"))
						{
							c = lc;s = ls;
						}
						else if(colorType.ToLower().StartsWith("[span"))
						{
							c = sc;s = ss;
						}
						code = Coloring(code,pattern,colorType,c[index],s[index]);
					}

					colorType = line.TrimEnd('\r');
					if(colorType.StartsWith("[Setting]"))
						break;
					pattern = "";
				}
				else
					pattern += line.TrimEnd('\r') + "|";
			}

			return TextUtility.ToQuotationText(code," ");
		}
		static string Coloring(string code,string pattern,string type,string color,string fontstyle)
		{
			_color = color;
			_style = fontstyle;
			if(type.ToLower().StartsWith("[word"))
			{
				pattern = @"\b" + pattern.Replace("|",@"\b|\b");
				pattern = pattern.Substring(0,pattern.Length-3);
				return Regex.Replace(code,pattern,new MatchEvaluator(ColoringProc));
			}
			else if(type.ToLower().StartsWith("[line"))
			{
				pattern = pattern.Replace("|",@"[^\r\n]*|");
				pattern = pattern.Substring(0,pattern.Length-1);
				return Regex.Replace(code,pattern,new MatchEvaluator(ColoringProc));
			}
			else if(type.ToLower().StartsWith("[span"))
			{
				pattern = pattern.Replace(" ",@".+?");
				pattern = pattern.Substring(0,pattern.Length-1);
				return Regex.Replace(code,pattern,new MatchEvaluator(ColoringProc),RegexOptions.Singleline);
			}
			else
				return code;
		}

		static string ColoringProc(Match match)
		{
			return "<span style=\"color:" + _color + ";" + _style + "\">" + match.Value + "</span>";
		}
	}
}
