using System;
using System.Text.RegularExpressions;

namespace RinGOch.WikiEngine.LineData.Chains
{
	public class ArrangedLineChain : LineChain
	{
		public ArrangedLineChain()
		{
		}

		protected override ILineData CreateLineData(string line)
		{
			Match match = Regex.Match(line, @"^(?<keyword>(LEFT:|CENTER:|RIGHT:))(?<content>.*)");

			if (match.Success) 
			{
				if(match.Groups["keyword"].Value == "LEFT:")
					return new ArrangedOnLeftLineData(match.Groups["keyword"].Value, match.Groups["content"].Value);
				if(match.Groups["keyword"].Value == "CENTER:")
					return new ArrangedOnCenterLineData(match.Groups["keyword"].Value, match.Groups["content"].Value);
				if(match.Groups["keyword"].Value == "RIGHT:")
					return new ArrangedOnRightLineData(match.Groups["keyword"].Value, match.Groups["content"].Value);
				else
					return null;
			}
			else
				return null;
		}
	}
}
