using System;
using System.Text.RegularExpressions;

namespace RinGOch.WikiEngine.LineData.Chains
{
	public class BlockquoteLineChain : LineChain
	{
		public BlockquoteLineChain()
		{}

		protected override ILineData CreateLineData(string line)
		{
			Match match = Regex.Match(line, @"^(?<keyword>(&gt;){1,3})(?<content>.*)");

			if (match.Success) 
				return new BlockquoteLineData(match.Groups["keyword"].Value, match.Groups["content"].Value);
			else
				return null;
		}
	}
}
