using System;
using System.Text;
using System.Text.RegularExpressions;

namespace RinGOch.WikiEngine.LineData
{
	/// <summary>
	/// dl^Oɑ΂L[[h [:] ܂ލs\NXłB
	/// </summary>
	public class DifinitionListLineData : StructuredLineData
	{
		private const string TAG_DL = "dl";

		public DifinitionListLineData(string keyword, string content) : base(keyword, content, TAG_DL,"")
		{}

		public override string GetContent()
		{
			StringBuilder builder = new StringBuilder();

			Match match = Regex.Match(base._content, @"^(?<dt>[^:]*)\|(?<dd>.*)");

			if (match.Success)
			{
				builder.Append("<dt>" + match.Groups["dt"].Value + "</dt>");
				builder.Append("<dd>" + match.Groups["dd"].Value + "</dd>");
				builder.Append("\r\n");
			}

			return builder.ToString();
		}
	}
}
