using System;

namespace RinGOch.WikiEngine.LineData
{
	public class HorizonLineData : ILineData
	{
		private string _keyword;
		private string _content;
		private string _tag;

		const string KEYWORD_HR = "----";
		const string TAG_HR = "hr";
		const string KEYWORD_P = "";
		const string TAG_P = "p";

		/// <summary>
		/// RXgN^ł
		/// </summary>
		/// <param name="keyword">L[[h</param>
		/// <param name="content">e</param>
		public HorizonLineData(string keyword,string content)
		{
			_keyword = keyword;
			_content = content;

			if(keyword == KEYWORD_HR)
				_tag = TAG_HR;
			else if(keyword == KEYWORD_P)
				_tag = TAG_P;
		}

		#region ILineData o

		public string Keyword
		{
			get
			{
				return _keyword;
			}
		}

		public string GetOpenTag(ILineData previous)
		{
			if(_keyword == KEYWORD_HR)
				return "<" + _tag + " />";
			else
				return "<" + _tag + ">";
		}

		public string GetCloseTag(ILineData next)
		{
			if(_keyword == KEYWORD_HR)
				return "\r\n";
			else
				return "</" + _tag + ">\r\n";
		}

		public string GetHeading()
		{
			return "";
		}

		public string GetContent()
		{
			return _content;
		}

		#endregion
	}
}
