using System;

namespace RinGOch.WikiEngine.LineData
{
	/// <summary>
	/// sf[^̃C^[tFCXł
	/// </summary>
	public interface ILineData
	{
		/// <summary>
		/// L[[h擾܂B
		/// </summary>
		string Keyword { get; }

		/// <summary>
		/// Jn^O擾܂
		/// </summary>
		/// <param name="previous">O̍s̃f[^</param>
		/// <returns>Jn^O</returns>
		string GetOpenTag(ILineData previous);

		/// <summary>
		/// I^O擾܂
		/// </summary>
		/// <param name="next">̍s̃f[^</param>
		/// <returns>^O</returns>
		string GetCloseTag(ILineData next);

		/// <summary>
		/// 擾܂
		/// </summary>
		/// <returns></returns>
		string GetHeading();

		/// <summary>
		/// e擾܂
		/// </summary>
		/// <returns>e</returns>
		string GetContent();
	}
}
